#include <pthread.h>     /* for POSIX threads */
#include <stdio.h>      /* for printf() and fprintf() */
#include <sys/socket.h> /* for socket(), bind(), and connect() */
#include <arpa/inet.h>  /* for sockaddr_in and inet_ntoa() */
#include <stdlib.h>     /* for atoi() and exit() */
#include <string.h>     /* for memset() */
#include <unistd.h>     /* for close() */
#include <time.h>
#include <sys/types.h>

#include "newcamd.h"
#include "des.h"
#include "newcamd-srv.h"
#include "newcamd-client.h"
#include "creg.h"


void DieWithError(char *errorMessage);  /* Error handling function */
int CreateTCPServerSocket(unsigned short port); /* Create TCP server socket */
int AcceptTCPConnection(int servSock);  /* Accept TCP connection request */
int CreateUDPServerSocket(unsigned short port); /* Create TCP server socket */

void *ThreadNewcamd(void *arg);		// Newcamd thread
void *Srv_status(void *);		// Status thread


pthread_mutex_t keymutex     = PTHREAD_MUTEX_INITIALIZER;
pthread_mutex_t loopmutex    = PTHREAD_MUTEX_INITIALIZER;
pthread_mutex_t ecmmutex     = PTHREAD_MUTEX_INITIALIZER;
pthread_mutex_t nccq         = PTHREAD_MUTEX_INITIALIZER;
pthread_mutex_t nccmutex[20];


/* Structure of arguments to pass to client threads */
struct NcdArgs				//newcamd connector args
{
	char 			conf1[200];	// NCD: port user pass  des
	unsigned  int		caid;
	unsigned  int		prv[20];
	int			prvcnt;
	unsigned int		sid[200];	//sid list
	int			sidcnt;		//sid count for N
	unsigned int 		cid[200];
	unsigned int		cidcnt;
	unsigned char		CardDataReq[255];
	int			CDRlen;
	bool			emm;
	pthread_t  		id;
};
struct NcdArgs 	Ncdlist[100];	/* array of NCD args */
int  	ncdcnt=0;


//NCC vars
struct NccArgs				//newcamd connector args for eacn N:
{
	char 		confn[200];		// N: line
	unsigned  int	caid;
	unsigned  int	prv[20];
	int		prvcnt;
	int 		prio;			// N priority
	unsigned int	sid[200];		//sid list
	int		sidcnt;			//sid count for N
	unsigned int	cid[200];
	int		cidcnt;
	bool		ready;
	unsigned char	ecmd[50];
	int		ecml;
};
struct NccArgs	Nlist[20];			//ncc liste
int	Ncnt=0;					//ncc count
newcamd_client	*Ncc[20];			//newcamd clients



// Newcamd active ECM list
struct ECMS
{
	unsigned short int sid;
	unsigned short int caid;
	unsigned int	prov;
	int 	sum;
	unsigned char ecm16[16];
	unsigned char reply[19];
};
struct 	ECMS 	ecmlist[200];			//ECM cahce list
int 	ECMcnt=0;				//active ecm nmber
int 	ECMmax=200;				//max ecm cache size

//struct	ECMs	ecmque[20];			//ECMs in process


struct ECMallow
{
unsigned char   data[20];
int		size;
int 		stat;
};
struct  ECMallow  ecl[10];
int	eclcnt=0;

int	Cardloop=0;		//Cardloop :0  for normal     >0 for loop time x 10sec
int	Cardact=0;

int	dbg;			//DEBUG
int	timeout=10000;



void delspace (char *Str1)
{
int Pntr = 0;
int Dest = 0;
while (Str1 [Pntr])
{
if (Str1 [Pntr] != ' ')
	Str1 [Dest++] = Str1 [Pntr];
Pntr++;
}
Str1 [Dest++] = 0;
}


///MAIN APPLICATION
int main(int argc, char *argv[])
{
unsigned short 	echoServPort;     /* Server port */
pthread_t	STT, NCD;      	/* Thread ID from pthread_create() */
FILE * 		isrtDosya;		// users.txt
char 		tmpstr[200];				//temp string for users.txt

int i,j,k;
char sidchr[4];
char prvchr[6];
char emmchr[2];
char channame[100];


	dbg=0;
	srand ( time(NULL) );
 	if (argc == 2) if (!strncmp(argv[1],"-d",2)) dbg=1;
	printf("\n-------------Registered Version------------\n");



	// parse config
	isrtDosya=fopen("proxy.cfg","r");
	if (isrtDosya==NULL)
		{
		fprintf(stderr,"File missing : proxy.cfg\n", argv[0]);
        	exit(1);
		}

	while ( fgets ( tmpstr, 200, isrtDosya ) != NULL )
		{
		if (strncmp(tmpstr,"Debug: ",7)==0) sscanf(tmpstr, "Debug: %d", &dbg);
		if (strncmp(tmpstr,"CACHE: ",7)==0) sscanf(tmpstr, "CACHE: %d", &ECMmax);
		if (strncmp(tmpstr,"LOOP: ",6)==0) sscanf(tmpstr, "LOOP: %d", &Cardloop);
		if (strncmp(tmpstr,"TIME: ",6)==0) sscanf(tmpstr, "TIME: %d", &timeout);
		if (strncmp(tmpstr,"ECMI: ",6)==0) 
			{
			delspace(tmpstr);
			for (j=0;j<(strlen(tmpstr)-5)/2;j++)
				{
				memcpy(sidchr,tmpstr+5+(j*2),2);
				sscanf(sidchr,"%2x",&i);
				ecl[eclcnt].data[j]=i;
				}
			ecl[eclcnt].size = j ;
			eclcnt++;
			}
		if (strncmp(tmpstr,"[CARD]",6)==0) 
			{
			fgets ( tmpstr, 200, isrtDosya );
			memcpy(Nlist[Ncnt].confn,tmpstr,200);
			fgets ( tmpstr, 200, isrtDosya );
			sscanf(tmpstr, "PRIO: %d", &Nlist[Ncnt].prio);
			fgets ( tmpstr, 200, isrtDosya );
			Nlist[Ncnt].sidcnt=0;
			Nlist[Ncnt].cidcnt=0;
			while (memcmp(tmpstr,"[END]",5) != 0 )
				{
				delspace(tmpstr);
				if (memcmp(tmpstr,"SID:",4) == 0 )
					{
					for (j=1;j<(strlen(tmpstr)/4);j++)
						{
						memcpy(sidchr,tmpstr+(j*4),4);
						sscanf(sidchr,"%4x",&Nlist[Ncnt].sid[j-1+Nlist[Ncnt].sidcnt]);
						}
					Nlist[Ncnt].sidcnt += j -1;
					}
				if (memcmp(tmpstr,"CID:",4) == 0 )
					{
					for (j=1;j<(strlen(tmpstr)/4);j++)
						{
						memcpy(sidchr,tmpstr+(j*4),4);
						sscanf(sidchr,"%4x",&Nlist[Ncnt].cid[j-1+Nlist[Ncnt].cidcnt]);
						}
					Nlist[Ncnt].cidcnt += j -1;
					}
				fgets ( tmpstr, 200, isrtDosya );
				}
			Ncnt++;
			}
		
		if (strncmp(tmpstr,"[NCD]",5)==0) 
			{
			fgets ( tmpstr, 200, isrtDosya );			
			memcpy(Ncdlist[ncdcnt].conf1,tmpstr,sizeof(tmpstr));		//conf 1  port user pass dess
			fgets ( tmpstr, 200, isrtDosya );
			Ncdlist[ncdcnt].emm =false;
			Ncdlist[ncdcnt].sidcnt=0;
			Ncdlist[ncdcnt].cidcnt=0;
			Ncdlist[ncdcnt].prvcnt=0;
			while (memcmp(tmpstr,"[END]",5) != 0 )
				{
				if (strncmp(tmpstr,"EMM: ",5)==0) sscanf(tmpstr, "EMM: %d", &Ncdlist[ncdcnt].emm);	
				if (strncmp(tmpstr,"CAID: ",6)==0) sscanf(tmpstr, "CAID: %4x", &Ncdlist[ncdcnt].caid);
					
				delspace(tmpstr);
				if (memcmp(tmpstr,"PRV:",4) == 0 )
					{
					for (j=0;j<(strlen(tmpstr+4)/6);j++)
						{
						memcpy(prvchr,tmpstr+(j*6)+4,6);
						sscanf(prvchr,"%6x",&Ncdlist[ncdcnt].prv[j]);
						}
					Ncdlist[ncdcnt].prvcnt = j;
					}
				if (memcmp(tmpstr,"SID:",4) == 0 )
					{
					for (j=1;j<(strlen(tmpstr)/4);j++)
						{
						memcpy(sidchr,tmpstr+(j*4),4);
						sscanf(sidchr,"%4x",&Ncdlist[ncdcnt].sid[j-1+Ncdlist[ncdcnt].sidcnt]);
						}
					Ncdlist[ncdcnt].sidcnt += j -1;
					}
				if (memcmp(tmpstr,"CID:",4) == 0 )
					{
					for (j=1;j<(strlen(tmpstr)/4);j++)
						{
						memcpy(sidchr,tmpstr+(j*4),4);
						sscanf(sidchr,"%4x",&Ncdlist[ncdcnt].cid[j-1+Ncdlist[ncdcnt].cidcnt]);
						}
					Ncdlist[ncdcnt].cidcnt += j -1;
					}
				fgets ( tmpstr, 200, isrtDosya );
				}
			ncdcnt++;
			}
		}

	fclose (isrtDosya);

	
	//if (!REG) 
		
	if (Ncnt>20) Ncnt=20; 
	if (ncdcnt>110) ncdcnt=110;


	// Startup of config
	printf("\n==================================\n");
	printf("Starting NCDserver... by billytk06\n");
	printf("Server Cache  : %d\n",ECMmax);
	printf("Server Timoeut: %d\n",timeout);
	//printf("Server Loop   : %d\n",Cardloop);
	printf("Server Debug  : %d\n",dbg);
	printf("Newcamd  (N)  : %d\n",Ncnt);
	printf("Newcamd (NCD) : %d\n\n",ncdcnt);


	// Create NCC mutexes
	for(int i=0;i<Ncnt;i++) pthread_mutex_init(&nccmutex[i], NULL);
	printf("%d Mutex init done.\n",Ncnt);

	// Create NCC clients
	for(int i=0;i<Ncnt;i++)
    		{
		printf("------------------------------------------\n");
		if (Ncc[i] = new newcamd_client(Nlist[i].confn,timeout-1000,VERSION_525), !Ncc[i])
			{
			perror("NEWCAMD Server #%d  Init Failed ");
			return(0);
			}
		Ncc[i]->dbg=dbg;
		Nlist[i].ready=Ncc[i]->is_ready();		//If NCC is ready > Nlist is ready
		if (Nlist[i].ready)
			{
			Nlist[i].caid=Ncc[i]->card_caid;
			Nlist[i].prvcnt=Ncc[i]->card_provider_id_count;
			for (j=0;j<Ncc[i]->card_provider_id_count;j++)  Nlist[i].prv[j]=Ncc[i]->card_provider_id[j];
			}
		}
	printf("%d Newcamd Clients Created.\n",Ncnt);

	// Print NCC status
	for(int i=0;i<Ncnt;i++)
    		{
		printf("NCC #%d Status :%d    (0=Down, 1=UP)\n",i,Ncc[i]->is_ready());
		}

	if (dbg)			//Print Ncc info in Nlist
	for (i=0;i<Ncnt;i++)
		{
		printf("\n---Card #%d ---\n",i);
		printf("%s",Nlist[i].confn);
		printf("PRIO : %d\n",Nlist[i].prio);
		printf("CAID : %04X\n",Nlist[i].caid);
		printf("PROV : %d > ",Nlist[i].prvcnt);
		for (j=0;j<Nlist[i].prvcnt;j++) printf("%06X ",Nlist[i].prv[j]);
		printf("\n");
		printf("SIDs : %d > ",Nlist[i].sidcnt);
		for (j=0;j<Nlist[i].sidcnt;j++) printf("%04x ",Nlist[i].sid[j]);
		printf("\n");
		printf("CIDs : %d > ",Nlist[i].cidcnt);
		for (j=0;j<Nlist[i].cidcnt;j++) printf("%04x ",Nlist[i].cid[j]);
		printf("\n");
		
		}

	// Crate NCD threads
	for(int i=0;i<ncdcnt;i++)
    		{
		if (pthread_create(&Ncdlist[i].id, NULL, ThreadNewcamd, NULL) != 0) DieWithError("pthread_create() failed");
		usleep(10000);
		}
	printf("%d NCD Threads Created.\n",ncdcnt);
	
	//Create System Status Thread..  //restores down NCCs
	if (pthread_create(&STT, NULL, Srv_status, NULL) != 0) DieWithError("pthread_create() failed");
	printf("System Status Thread Created.\n-------------------------------\n",Ncnt);

	if (dbg) usleep(500000);

	for(int i=0;i<eclcnt;i++)
		{
		printf("ECMI (%d) :",ecl[i].size);
		for(int j=0;j<ecl[i].size;j++)
			printf("%02X",ecl[i].data[j]);
		printf("\n");
		}

	while (1)
		{
		sleep(100);
		}

      

}



// -------- NEWCAMD THREAD
void *ThreadNewcamd(void * ncdparam )
{

//newcamd srv init variables
newcamd_srv 	*Ncs;
int	 	nsock;				// server socket
int		nport;				//server port
int 		nclntSock;                  	// Socket descriptor for client connection
sockaddr_in 	claddr;
socklen_t 	clen;
char 		cl_ip[20];			// Client IP
pthread_t 	thrid;				//thread id to find NCD..

int ix,iy,iz;
char 		tmpc[20];
int ActNcs;
unsigned char 	mycdr[255];
unsigned int	mycdrsize;
int   	tmpb;

int	ncschid;
int 	ncsprov;
bool	allowed;
int 	kart;
int	Routes[20];
int	Roucnt;



thrid=pthread_self();
pthread_detach(pthread_self()); 
for (ix=0;ix<ncdcnt;ix++) 
    if (Ncdlist[ix].id==thrid)
	{
	printf("\n---------------------------------------\nParsing NCD[%d] conf\n",ix);
	printf("CONF : %s",Ncdlist[ix].conf1);
	printf("CAID : %04X\n",Ncdlist[ix].caid);
	printf("PROV : ");
	for (iy=0;iy<Ncdlist[ix].prvcnt;iy++) printf("%06X ",Ncdlist[ix].prv[iy]);
	printf("\nSID  : ");
	for (iy=0;iy<Ncdlist[ix].sidcnt;iy++) printf("%04X ",Ncdlist[ix].sid[iy]);
	printf("\nCHID : ");
	for (iy=0;iy<Ncdlist[ix].cidcnt;iy++) printf("%04X ",Ncdlist[ix].cid[iy]);
	printf("\n");
	break;
	}

sscanf(Ncdlist[ix].conf1, "NCD: %s %d", tmpc, &nport );
ActNcs=ix;
printf("Server Port : %d\n",nport);

memset (mycdr,0,sizeof(mycdr));
mycdr[0]=3;
sprintf(tmpc,"%04X",Ncdlist[ix].caid);
//printf("Caid : %s ",tmpc);
sscanf(tmpc, "%2X", &tmpb); mycdr[1]=tmpb; 		//printf("%2x",tmpb);
sscanf(tmpc+2, "%2X", &tmpb); mycdr[2]=tmpb; 		// printf("%2x",tmpb);
mycdr[11]=Ncdlist[ix].prvcnt;
for (iz=0;iz<Ncdlist[ix].prvcnt;iz++)
	{
	sprintf(tmpc,"%06X",Ncdlist[ix].prv[iz]);
	//printf("\nProv : %s",tmpc);
	sscanf(tmpc, "%2X", &tmpb); // printf("%2x",tmpb);
	mycdr[12+12*iz-iz]=tmpb; 		
	sscanf(tmpc+2, "%2X",&tmpb); // printf("%2x",tmpb);
	mycdr[13+12*iz-iz]=tmpb; 		
	sscanf(tmpc+4, "%2X", &tmpb); // printf("%2x\n",tmpb);
	mycdr[14+12*iz-iz]=tmpb; 		
	}
mycdrsize=Ncdlist[ix].prvcnt*12+12;
//OK to start

START_N:
printf("Started Newcamd Connector : NCD[%d].\n",ActNcs);
nsock = CreateTCPServerSocket(nport);
if (nsock<=0)  printf ("NCD[%d] Error in Create Socket :\n",ActNcs,nsock);
nclntSock = AcceptTCPConnection(nsock);
if (nclntSock<=0)  printf ("NCD[%d] Error in Accept Socket : %d\n",ActNcs,nclntSock);
if (shutdown(nsock, 2)<0) perror("Socket shutdown at startup");
close(nsock);
clen = sizeof(claddr);
getpeername(nclntSock, (sockaddr*)&claddr, &clen);
strcpy(cl_ip,inet_ntoa(claddr.sin_addr));
if (Ncs = new newcamd_srv(Ncdlist[ActNcs].conf1,timeout,VERSION_525,nclntSock,mycdr,mycdrsize), !Ncs)
		{
		perror("NEWCAMD Server [] Failed");
		sleep(3);
		goto START_N;
		}
Ncs->dbg=dbg;
if (Ncs->is_ready())  printf("NCD[%d] is ready to recieve ECMs\n",ActNcs);  else printf("NCD[%d] can not started.\n",ActNcs); 
while (Ncs->is_ready())
	if (Ncs->checkdata())
		{
		if (!Ncs->is_ready()) break;
// 1.  Find if allowed by NCD line
		allowed=false;
		if (Ncdlist[ActNcs].sidcnt>0)
			{
			for (iz=0;iz<Ncdlist[ActNcs].sidcnt;iz++)
				if (Ncdlist[ActNcs].sid[iz]==Ncs->SID)
					{
					allowed=true;
					if  (Ncdlist[ActNcs].cidcnt>0) 
						{
						ncschid= (Ncs->ECMbuffer[6]<<8)+Ncs->ECMbuffer[7];
						if (Ncdlist[ActNcs].cid[iz]!=ncschid) allowed=false;
						}
					break;	
					}
			} else allowed=true;
		if (dbg) { if (allowed)  printf("NCD[%d] SID / CHID  Allowed.\n",ActNcs); else printf("NCD[%d] SID / CHID  NOT Allowed.\n",ActNcs); }
		if (!allowed) goto CEVAP;

// 2. 	Find in Cache
		pthread_mutex_lock( &ecmmutex );
		for (ix=0;ix<ECMmax;ix++)
			if ( (ecmlist[ix].sum==Ncs->ecmcrc) && (ecmlist[ix].caid==Ncs->card_caid) && (ecmlist[ix].prov==Ncs->PROVID) ) 
				if ( (ecmlist[ix].sid==Ncs->SID) && (memcmp(ecmlist[ix].ecm16,Ncs->ECMbuffer,16)==0) )
					{
			   		memcpy(Ncs->ECMbuffer,ecmlist[ix].reply,19);
					pthread_mutex_unlock( &ecmmutex );
					if (dbg) printf("NCD[%d] Forwarded (1) from cache to %s\n",ActNcs,cl_ip);
					goto CEVAP;
					}	
		pthread_mutex_unlock( &ecmmutex );


// 3.  	Find Route 
FINDROUTE:

		Roucnt=0;
		if (dbg) printf("NCD[%d] Finding routes for Prov:%06X  Caid:%04X  SID:%04X\n",ActNcs,Ncs->PROVID,Ncs->card_caid,Ncs->SID);
		for (iz=0;iz<Ncnt;iz++)
		    if ((Ncs->card_caid==Nlist[iz].caid) && Nlist[iz].ready)
			for (iy=0;iy<Nlist[iz].prvcnt;iy++)
			    if (Nlist[iz].prv[iy]==Ncs->PROVID)
				{
				if (Nlist[iz].sidcnt==0)
					{
					Routes[Roucnt]=iz;
					Roucnt++;
					break;	
					}
				for (ix=0;ix<Nlist[iz].sidcnt;ix++)	
					if (Nlist[iz].sid[ix]==Ncs->SID)	
						{
						Routes[Roucnt]=iz;
						Roucnt++;
						break;
						}	
				break;
				}
		if (dbg)
		   for (iz=0;iz<Roucnt;iz++)
			{
			if (dbg) printf("NCD[%d] Found Route on Card#%d\n",ActNcs,Routes[iz]);
			}
		if (Roucnt==0)
			{
			allowed=false;
			if (dbg) printf("NCD[%d] There is No Route \n",ActNcs);
			goto CEVAP;
			}
		
		kart=Routes[rand() % Roucnt];	
		if (dbg) printf("NCD[%d] Selected Route Card[%d]\n",ActNcs,kart);
		   	

// 4. 	Forward ECM
FORWARD:
		pthread_mutex_lock( &nccmutex[kart] );
		if (dbg) printf("%d\n",Ncc[kart]->is_ready() );
		pthread_mutex_lock( &ecmmutex );
		for (ix=0;ix<ECMmax;ix++)
			if ( (ecmlist[ix].sum==Ncs->ecmcrc) && (ecmlist[ix].caid==Ncs->card_caid) && (ecmlist[ix].prov==Ncs->PROVID) ) 
				if ( (ecmlist[ix].sid==Ncs->SID) && (memcmp(ecmlist[ix].ecm16,Ncs->ECMbuffer,16)==0) )
					{
			   		memcpy(Ncs->ECMbuffer,ecmlist[ix].reply,19);
					pthread_mutex_unlock( &ecmmutex );
					pthread_mutex_unlock( &nccmutex[kart] );
					if (dbg) printf("NCD[%d] Forwarded (2) from cache to %s\n",ActNcs,cl_ip);
					goto CEVAP;
					}	
		pthread_mutex_unlock( &ecmmutex );

		if (!Ncc[kart]->is_ready())
			{
			Nlist[kart].ready=false;
			if (dbg) printf("NCD[%d]  Card[%d] is down. Finding Routes again.\n",ActNcs,kart);
			pthread_mutex_unlock( &nccmutex[kart] );
			goto FINDROUTE;
			}
		if (dbg) printf("NCD[%d]  ECM sent to Card[%d]\n",ActNcs,kart);
		Ncc[kart]->send_ecm(Ncs->ECMbuffer,Ncs->ECMsize,Ncs->SID);
		if (Ncc[kart]->is_ready() && (Ncc[kart]->echobufsize==19))
			{
			if (dbg) printf("NCD[%d] New DCW to %s === Prov:%06X  Caid:%04X  SID:%04X\n",ActNcs,cl_ip,Ncs->PROVID,Ncs->card_caid,Ncs->SID);
			pthread_mutex_lock( &ecmmutex );
			ecmlist[ECMcnt].sum=Ncs->ecmcrc;
			ecmlist[ECMcnt].sid=Ncs->SID;
			ecmlist[ECMcnt].caid=Ncs->card_caid;
			ecmlist[ECMcnt].prov=Ncs->PROVID;
			memcpy(ecmlist[ECMcnt].reply,Ncc[kart]->echobuf,19);
			memcpy(ecmlist[ECMcnt].ecm16,Ncs->ECMbuffer,16);
			ECMcnt++;
			if (ECMcnt==ECMmax) ECMcnt=0;
			pthread_mutex_unlock( &ecmmutex );
			memcpy(Ncs->ECMbuffer,Ncc[kart]->echobuf,19);
			} else allowed=false;	
		Nlist[kart].ready=Ncc[kart]->is_ready();
		pthread_mutex_unlock( &nccmutex[kart] );
		

CEVAP:		//Send message
		//if (dbg)  printf("NCD[%d] Before ---> stat: %d     Card[%d] Stat: %d\n",ActNcs,Ncs->is_ready(),kart,Nlist[kart].ready);
		if ((!allowed))
			{
			Ncs->ECMbuffer[1]=0;
			Ncs->ECMbuffer[2]=0;
			Ncs->Sendecho(Ncs->ECMbuffer,3);
			} else Ncs->Sendecho(Ncs->ECMbuffer,19);
		if (dbg  && (kart>=0)) printf("NCD[%d] After ---> stat: %d     Card[%d] Stat: %d\n",ActNcs,Ncs->is_ready(),kart,Nlist[kart].ready);
		if (!Ncs->is_ready()) break;
		}

delete(Ncs);
printf("NCD[%d] connector closed.\n\n",ActNcs);
sleep(1);
goto START_N;

return (NULL);

}



void *Srv_status(void * )
{
int x,i,kart;
int loop;

pthread_detach(pthread_self()); 
loop=0;
while (1)
	{
	sleep(1);
	if (Cardloop>0)
		{
		loop++;
		if (loop==Cardloop) loop=0;
		if (loop==0)
			{
			i=0;
			pthread_mutex_lock( &loopmutex );
			kart=Cardact;
			kart++;
			if (kart==Ncnt) kart=0;
			while ((i<Ncnt) && (!Nlist[kart].ready) )
					{ 
					i++; kart++; 
					if (kart==Ncnt) kart=0;
					}
			Cardact=kart;
			pthread_mutex_unlock( &loopmutex );
			}
		}

	for (x=0;x<Ncnt;x++) 
	   if (!Nlist[x].ready)
		{
		pthread_mutex_lock( &nccmutex[x] );
		delete(Ncc[x]);
		printf("------------INIT NCC %d ------------------------------\n",x);
		if (Ncc[x] = new newcamd_client(Nlist[x].confn,timeout-1000,VERSION_525), !Ncc[x])
			perror("NEWCAMD Server #%d  Init Failed ");
		Ncc[x]->dbg=dbg;
		Nlist[x].ready=Ncc[x]->is_ready();
		pthread_mutex_unlock( &nccmutex[x] );
		}
	}

return (NULL);
}

